final def isWindows = (System.getProperty('os.name') =~ /(?i)windows/).find()
out = System.out;
def wsadmin = isWindows ? "wsadmin.bat" : "wsadmin.sh"

final def workDir = new File('.').canonicalFile
final def props = new Properties();
final def inputPropsFile = new File(args[0]);
final def inputPropsStream = null;
try {
    inputPropsStream = new FileInputStream(inputPropsFile);
    props.load(inputPropsStream);
}
catch (IOException e) {
    throw new RuntimeException(e);
}

def cell = props['cell']
def server = props['server']
def commandPath = (props['commandPath']!=null?props['commandPath']:"");
def node = props['node']
def user = props['user']
def password = (props['password'] != null && props['password'] != "")? props['password'] : props['passScript']
def cluster = props['cluster']
def appName = props['appName']
def appType = props['appType']

def connType = props['connType']
def host = props['host'];
def port = props['port'];
def additionalArgs = props['additionalArgs'];


    
File tempFile = new File("temp.py")
BufferedWriter temp = new BufferedWriter(new FileWriter(tempFile))
def cellarg = cell ? " -cell " + cell : ""

def invoke = """
import sys

appInstalled = 0
apps = AdminApp.list()
for app in apps.splitlines():
    if (app == '${appName}'):
        appInstalled = 1
        break
    else:
       pass

if (appInstalled == 1):
    print "Application is installed!"
else:
    print "Application is not currently installed!"
    sys.exit(1)

""";

if (cluster) {
invoke += """
clusterMembers = AdminConfig.list('ClusterMember', AdminConfig.getid('/ServerCluster:${cluster}/')).splitlines()
for member in clusterMembers:
    memberName = AdminConfig.showAttribute(member, 'memberName').strip();
    appRun = None;
    names = AdminControl.queryNames('type=${appType},name=${appName},*').splitlines();
    if len(names) == 0 or (len(names) == 1 and names[0] == ''):
        print 'App not running on any server';
        sys.exit(1);
    else:
        for app in names:
            server = AdminControl.getAttributes(app, ['server']).split(' ')[1][:-1];
            serverName = AdminControl.getAttributes(server, ['name']).split(' ')[1][:-1];
            if serverName.strip() == memberName:
                appRun=app;
 
    if appRun == None:
        print 'App not running on server ' + memberName;
    else:
        print 'App is running on server ' + memberName;
""";
    println invoke;
    temp.write(invoke);
}
else {
invoke += """
appRun = None;
names = AdminControl.queryNames('type=${appType},name=${appName},*').splitlines();
if len(names) == 0 or (len(names) == 1 and names[0] == ''):
    print 'App not running on any server server1';
    sys.exit(1);
else:
    for app in names:
        server = AdminControl.getAttributes(app, ['server']).split(' ')[1][:-1];
        serverName = AdminControl.getAttributes(server, ['name']).split(' ')[1][:-1];
        if serverName.strip() == '${server}':
            appRun=app;
 
if appRun == None:
    print 'App not running on server ${server}';
    sys.exit(1);
print 'App is running on server ${server}';
sys.exit(0)
"""
    println invoke;
    temp.write(invoke);
}

temp.close();
def commandArgs = [commandPath + wsadmin, "-lang", "jython"];
commandArgs << "-conntype"
commandArgs << connType.trim();

if (host) {
    commandArgs << "-host";
    commandArgs << host;
}

if (port) {
    commandArgs << "-port";
    commandArgs << port;
}

if (user) {
    commandArgs << "-user"
    commandArgs <<  user
    commandArgs << "-password"
    commandArgs << password
}
commandArgs << "-f"
commandArgs << "temp.py";

if (additionalArgs) {
    additionalArgs.split('\n').each { arg ->
        commandArgs << arg;
    }
}

println commandArgs.join(' ');
def procBuilder = new ProcessBuilder(commandArgs);

if (isWindows) {
    def envMap = procBuilder.environment();
    envMap.put("PROFILE_CONFIG_ACTION","true");
}

def statusProc = procBuilder.start();
def outPrint = new PrintStream(out, true);
statusProc.waitForProcessOutput(outPrint, outPrint);
System.exit(statusProc.exitValue());
