import java.io.*;
import java.util.*;

final def isWindows = (System.getProperty('os.name') =~ /(?i)windows/).find()
out = System.out;
def wsadmin = isWindows ? "wsadmin.bat" : "wsadmin.sh"

final def workDir = new File('.').canonicalFile
final def props = new Properties();
final def inputPropsFile = new File(args[0]);
final def inputPropsStream = null;
try {
    inputPropsStream = new FileInputStream(inputPropsFile);
    props.load(inputPropsStream);
}
catch (IOException e) {
    throw new RuntimeException(e);
}

def cell = props['cell']
def server = props['server']
def commandPath = (props['commandPath']!=null?props['commandPath']:"");
def node = props['node']
def user = props['user']
def password = (props['password'] != null && props['password'] != "")? props['password'] : props['passScript']
def cluster = props['cluster']

def connType = props['connType']
def host = props['host'];
def port = props['port'];
def additionalArgs = props['additionalArgs'];
def appServerRootDir = props['appServerRootDir'];
def configRepoRootDir = props['configRepoRootDir'];
def fileName = props['fileName'];
def propagate = props['propagate'];
def propKeyRing = props['propagateKeyRing'];

                        
File tempFile = new File("temp.py")
tempFile.deleteOnExit();


BufferedWriter temp = new BufferedWriter(new FileWriter(tempFile))
def current = "cell = AdminControl.getCell()";
temp.write(current, 0, current.length());
System.out.print(current)
current = "\npluginGen = AdminControl.completeObjectName('type=PluginCfgGenerator,*')";
temp.write(current, 0, current.length());
System.out.print(current)
String invokeArgs = appServerRootDir + " " + configRepoRootDir + " " + 
        "' + cell + ' null null " + fileName; 
String invokeCmd = "AdminControl.invoke(pluginGen,'generate', '" + invokeArgs + "')"; 
invokeCmd = "\n" + invokeCmd + "\n";
temp.write(invokeCmd, 0, invokeCmd.length());
System.out.print(invokeCmd);
temp.close();

def commandArgs = [commandPath + wsadmin, "-lang", "jython"];
commandArgs << "-conntype"
commandArgs << connType.trim();

if (host) {
    commandArgs << "-host";
    commandArgs << host;
}

if (port) {
    commandArgs << "-port";
    commandArgs << port;
}

if (user) {
    commandArgs << "-user"
    commandArgs <<  user
    commandArgs << "-password"
    commandArgs << password
}

commandArgs << "-f";
commandArgs << "temp.py";

if (additionalArgs) {
    additionalArgs.split('\n').each { arg ->
        commandArgs << arg;
    }
}

println commandArgs.join(' ');
def procBuilder = new ProcessBuilder(commandArgs);

if (isWindows) {
    def envMap = procBuilder.environment();
    envMap.put("PROFILE_CONFIG_ACTION","true");
}


def statusProc = procBuilder.start();
def outPrint = new PrintStream(out, true);
statusProc.waitForProcessOutput(outPrint, outPrint);
System.exit(statusProc.exitValue());
