final def isWindows = (System.getProperty('os.name') =~ /(?i)windows/).find()
out = System.out;
def wsadmin = isWindows ? "wsadmin.bat" : "wsadmin.sh"

final def workDir = new File('.').canonicalFile
final def props = new Properties();
final def inputPropsFile = new File(args[0]);
final def inputPropsStream = null;
try {
    inputPropsStream = new FileInputStream(inputPropsFile);
    props.load(inputPropsStream);
}
catch (IOException e) {
    throw new RuntimeException(e);
}

def cell = props['cell']
def server = props['server']
def commandPath = (props['commandPath']!=null?props['commandPath']:"");
def node = props['node']
def user = props['user']
def password = (props['password'] != null && props['password'] != "")? props['password'] : props['passScript']
def cluster = props['cluster']

def connType = props['connType']
def host = props['host'];
def port = props['port'];
def additionalArgs = props['additionalArgs'];
appName = props['appName']
File tempFile = new File("temp.py")
tempFile.deleteOnExit();
BufferedWriter temp = new BufferedWriter(new FileWriter(tempFile))


def queryNames =""
if(cluster)
{
  queryNames = "AdminConfig.getid('/ServerCluster:"+cluster+"/')"
  queryNames = "clusterMembers = AdminConfig.list('ClusterMember', "+queryNames+").splitlines()\n"
  temp.write(queryNames, 0, queryNames.length())
  System.out.print queryNames
  def startapp = "hasError = 0\n";
  temp.write(startapp,0,startapp.length())
  System.out.print startapp
  startapp = "for member in clusterMembers:\n"
  temp.write(startapp,0,startapp.length())
  System.out.print startapp
  startapp = "\ttry:\n"
  temp.write(startapp,0,startapp.length())
  System.out.print startapp
  startapp = "\t\tserver = AdminConfig.showAttribute(member, 'memberName')\n"
  temp.write(startapp,0,startapp.length())
  System.out.print startapp
  startapp = "\t\tnode = AdminConfig.showAttribute(member, 'nodeName')\n"
  temp.write(startapp,0,startapp.length())
  System.out.print startapp
  startapp = "\t\tappMan=AdminControl.queryNames('node='+node+',type=ApplicationManager,process='+server+',*')\n"
  temp.write(startapp,0,startapp.length())
  System.out.print startapp
  startapp = "\t\tAdminControl.invoke(appMan, 'stopApplication', '" + appName + "')\n\n"
  temp.write(startapp,0,startapp.length())
  System.out.print startapp
  startapp = "\texcept Error:\n";
  temp.write(startapp,0,startapp.length())
  System.out.print startapp
  startapp = "\t\thasError=1\n"
  temp.write(startapp,0,startapp.length())
  System.out.print startapp
  startapp = "\n"
  temp.write(startapp,0,startapp.length())
  System.out.print startapp
  startapp = "if hasError == 1:\n"
  temp.write(startapp,0,startapp.length())
  System.out.print startapp
  startapp = "\tsys.exit(1)\n";
  temp.write(startapp,0,startapp.length())
  System.out.print startapp
  startapp = "sys.exit(0)\n";
  temp.write(startapp,0,startapp.length())
  System.out.print startapp
  temp.close()
} else {
  queryNames = "AdminControl.queryNames('type=ApplicationManager,process=" + server + ",node=" + node + ",*')"
  def invoke = "AdminControl.invoke(" + queryNames + ", \"stopApplication\", \"" + appName + "\")"
  temp.write(invoke, 0, invoke.length())
  System.out.print invoke
  temp.close()
}

def commandArgs = [commandPath + wsadmin, "-lang", "jython"];
commandArgs << "-conntype"
commandArgs << connType.trim();

if (host) {
    commandArgs << "-host";
    commandArgs << host;
}

if (port) {
    commandArgs << "-port";
    commandArgs << port;
}

if (user) {
    commandArgs << "-user"
    commandArgs <<  user
    commandArgs << "-password"
    commandArgs << password
}

commandArgs << "-f";
commandArgs << "temp.py";

if (additionalArgs) {
    additionalArgs.split('\n').each { arg ->
        commandArgs << arg;
    }
}

println "\n" + commandArgs.join(' ');
def procBuilder = new ProcessBuilder(commandArgs);

if (isWindows) {
    def envMap = procBuilder.environment();
    envMap.put("PROFILE_CONFIG_ACTION","true");
}

def statusProc = procBuilder.start();
def outPrint = new PrintStream(out, true);
statusProc.waitForProcessOutput(outPrint, outPrint);
System.exit(statusProc.exitValue());
