
final def isWindows = (System.getProperty('os.name') =~ /(?i)windows/).find()
out = System.out;
def wsadmin = isWindows ? "wsadmin.bat" : "wsadmin.sh"

final def workDir = new File('.').canonicalFile
final def props = new Properties();
final def inputPropsFile = new File(args[0]);
final def inputPropsStream = null;
try {
    inputPropsStream = new FileInputStream(inputPropsFile);
    props.load(inputPropsStream);
}
catch (IOException e) {
    throw new RuntimeException(e);
}

def cell = props['cell']
def server = props['server']
def commandPath = (props['commandPath']!=null?props['commandPath']:"");
def node = props['node']
def user = props['user']
def password = (props['password'] != null && props['password'] != "")? props['password'] : props['passScript']
def cluster = props['cluster']

def connType = props['connType']
def host = props['host'];
def port = props['port'];
def additionalArgs = props['additionalArgs'];
def immediate = Boolean.valueOf(props['immediate']);

File tempFile = new File("temp.py")
tempFile.deleteOnExit();
BufferedWriter temp = new BufferedWriter(new FileWriter(tempFile))
def cellarg = cell ? " -cell " + cell : ""

def clusterScript = """
cluster = AdminConfig.getid("/ServerCluster:${cluster}/");
clusterMembers = AdminConfig.list('ClusterMember', cluster).splitlines();
for member in clusterMembers:
    server = AdminConfig.showAttribute(member, 'memberName')
    nodeName = AdminConfig.showAttribute(member, 'nodeName')
    nodeAgent = AdminControl.queryNames('node=' + nodeName + ',type=NodeAgent,*');
    print "Invoking terminate command on node " + nodeName + " for server " + server; 
    AdminControl.invoke(nodeAgent, 'terminate', '[' + server + ']', '[java.lang.String]');
""";

def serverScript = """
nodeAgent = AdminControl.queryNames('node=${node},type=NodeAgent,*');
print "Invoking terminate command on node ${node} for server ${server}"; 
AdminControl.invoke(nodeAgent, 'terminate', '[${server}]', '[java.lang.String]');
""";

if(cluster) {
  invoke = clusterScript;
} else {
  invoke = serverScript;
}
temp.write(invoke, 0, invoke.length())
System.out.println invoke;
temp.close()

def commandArgs = [commandPath + wsadmin, "-lang", "jython"];
commandArgs << "-conntype"
commandArgs << connType.trim();

if (host) {
    commandArgs << "-host";
    commandArgs << host;
}

if (port) {
    commandArgs << "-port";
    commandArgs << port;
}

if (user) {
    commandArgs << "-user"
    commandArgs <<  user
    commandArgs << "-password"
    commandArgs << password
}

commandArgs << "-f";
commandArgs << "temp.py";

if (additionalArgs) {
    additionalArgs.split('\n').each { arg ->
        commandArgs << arg;
    }
}

println commandArgs.join(' ');
def procBuilder = new ProcessBuilder(commandArgs);

if (isWindows) {
    def envMap = procBuilder.environment();
    envMap.put("PROFILE_CONFIG_ACTION","true");
}

def statusProc = procBuilder.start();
def outPrint = new PrintStream(out, true);
statusProc.waitForProcessOutput(outPrint, outPrint);
System.exit(statusProc.exitValue());
